<?php
/************************************************************************************************

This file contains all the shit to grab a beast out of the database, and spit it out as 
javascript and html. 

Several arrays are created with all the Neural Networks weights, biases and nodes. 
The NN is run in three stages:
	Stage 1: generates all the layers.
	Stage 2: animated all of those layers, and learn from user input. 
	Stage 3: will submit what has been learnt back to the database.

************************************************************************************************/

require ("../include/mysqls.php3");

//**** Search for a beast by id or name. ****
if ($id){ 
	$result = DQ("SELECT *,(TO_DAYS(CURDATE()) - TO_DAYS(DOB)) AS age FROM nn_beasts WHERE ID ='$id'"); 
}else{
	if ($name){ 
		$result = DQ("SELECT *,(TO_DAYS(CURDATE()) - TO_DAYS(DOB)) AS age FROM nn_beasts WHERE Name LIKE '$name'"); 
	}
}


//*** Ok so no input was given, redirect to garden page. ****
if (!$result){
	header ("Location: garden.php3");
	exit();
}else{
	//*** fetch result and find out it's age. ***
	$buf = mysql_fetch_array($result);

	//** check beast is alive. ***
	if ($buf['Alive'] == 0){
		die ("This Beast has died.");
	}

	//*** increment hits counter. ***
	DQ ("UPDATE nn_beasts SET Hits = (Hits+1) WHERE ID='".$buf['ID']."'");
}


require ("common.php3");


spitHeader("A Little Beast Called " . $buf['Name']);
spitJSIncludes();

//**** Big chunk of Javacript to be spat into header of page. ****
echo "<SCRIPT LANGUAGE=\"javascript1.2\" type=\"text/javascript\">\n";
echo "<!--\n";

echo "var BeastID = " . $buf['ID'] . "\n";

$result2 = DQ("SELECT * FROM nn_layers WHERE BeastID = '" . $buf['ID'] . "' AND Type != '0' ORDER BY ID");

echo "var LayerIDs = new Array();\n";
echo "var LayerTraining = new Array();\n\n";

$i = 0;

echo "//*** Weight Matrices and node arrays for each layer of nodes. ***\n";
while ($buf2 = mysql_fetch_array($result2)){
	echo "LayerTraining[$i] = \"" . $buf2['Training'] . "\";\n";
	spitWeightMatrix($buf2['ID']);
	echo "LayerIDs[$i] = " . $buf2['ID'] . ";\n";
	spitLayerOfNodes($buf2['ID']);	
	$i++;
}

spitInputJSFunc($buf['ID']);
spitOutputJSFunc($buf['ID']);


echo "//-->\n";
echo "</SCRIPT>\n";

//*********** Right, that's all the header done. ********
//spitBodyTag();
?>

<SCRIPT LANGUAGE="javascript1.2" type="text/javascript">
<!--

<?php spitNumOfSquares($buf['ID']); ?>

var LayerIndex = new Array(0,0,0,0);


function spitBeastLayers(){
	for (n=0; n<NumOfSquares; n++){
		var out = new Array();
		getInput();		
		evalNN(inputP, out);
		spitLayer('Square'+n, 
				OutputFuncs['layerWidth'], 
				OutputFuncs['layerHeight'],
				OutputFuncs['layerX'], 
				OutputFuncs['layerY'],
				'#FF0000');
		
	}
	TrainingOn = true;

<?php if (!$debug){ echo "setTimeout('updateBeast()', 500);\n"; } ?>

}

function updateBeast(){
	for (n=0; n<NumOfSquares; n++){
		out = new Array();
		sortLayerIndex(n, LayerIndex);
		getInput();		
		spitDebug("<HR width=100%><B>Start Input, Layer "+n+"</B>");
		evalNN(inputP, out);
		sortOutput( layerNames['Square'+n], out, OutputFuncs);
		spitDebug("<HR width=100%>");
	}
	delete out;

<?php if (!$debug){ echo "setTimeout('updateBeast()', 500);\n"; } ?>

}
//-->
</SCRIPT>

</HEAD>

<?php

//**** check for $NoSubmit variable, cause if it's there we don't submit on leaving. 
if ($NoSubmit){
	echo "<BODY onLoad=\"spitBeastLayers();\" CLASS=\"light\" onResize=\"reshape()\">\n";
}else{
	echo "<BODY onLoad=\"spitBeastLayers();\" onUnload=\"updateDB();\" onResize=\"reshape()\" CLASS=\"light\">\n";
}


spitToolbar($buf['ID']);

echo "<H4 CLASS='light'>\n";
echo "Name: " . $buf['Name'] . ".<BR>\n";
echo "Age: " .$buf['age'] . " days.<BR>\n";
echo "Structure: " .$buf['Structure'] . ".<BR>\n";
echo "</H4>\n\n";


echo "<BR><BR><BR>\n\n";

	//** See if we want debugging links available. ****
	if ($debug){
		echo "<A HREF=\"javascript: openDebugWindow();\">Debug Window</A> | \n";
		echo "<A HREF=\"javascript: updateBeast();\" onMouseOver=\"updateBeast();\">Step</A>\n";
	}
?>

<SCRIPT LANGUAGE="javascript1.2" type="text/javascript">
<!--
reshape();
//-->
</SCRIPT>

</BODY>
</HTML>
