//****** Globals *****
var MaxMouseHistory = 5;		//** size of mouse position history. 
var MouseCoordX = new Array();	//** Arrays to sotre history of mouse positions. 
var MouseCoordY = new Array();
//*** init arrays to zero. ***
for (i=0; i<MaxMouseHistory; i++){
	MouseCoordX[i] = 0;
	MouseCoordY[i] = 0;
}

var timeNow = new Date();

var foodTimeOut = 3000;
var gotCheese = -1;
var gotCoffee = -1;
var gotBison = -1;

//*** little variable for the sinTheta and cosTheta functions. ***
var theta = 0;


var OutstarAlpha = 0.01;

function thumbsUp(){
	if (OutstarAlpha < 1){
		OutstarAlpha += 0.01;
	}
	setTimeout("if (OutstarAlpha > 0.01) OutstarAlpha -= 0.01;", 500);
}


/*******************************************************************************************************

Big chunk for grabbing all the input for the Beasts.

*******************************************************************************************************/


//**** Cheese! - unconditional input... *****
function giveCheese(){
	if (gotCheese != 1){
		gotCheese = 1;
		eval(refName("Toolbar", "CheeseImg") + ".src='images/alpha.gif'");
		setTimeout("sortCheese();", foodTimeOut);
	}
}

function sortCheese(){
	gotCheese = -1;	
	eval(refName("Toolbar", "CheeseImg") + ".src='images/cheese.gif'");
}

//*********************************************
function giveCoffee(){
	if (gotCoffee != 1){
		gotCoffee = 1;
		eval(refName("Toolbar", "CoffeeImg") + ".src='images/alpha.gif'");
		setTimeout("sortCoffee();", foodTimeOut);
	}
}

function sortCoffee(){
	gotCoffee = -1;	
	eval(refName("Toolbar", "CoffeeImg") + ".src='images/coffee.gif'");
}

//******************************************
function giveBison(){
	if (gotBison != 1){
		gotBison = 1;
		eval(refName("Toolbar", "BisonImg") + ".src='images/alpha.gif'");
		setTimeout("sortBison();", foodTimeOut);
	}
}

function sortBison(){
	gotBison = -1;	
	eval(refName("Toolbar", "BisonImg") + ".src='images/bison.gif'");
}

//************** Bit to grab the mouse down events so we know the mouses positions. ************
function getMousePos(mouseEvent){
	for (var i = MaxMouseHistory-1; i>0; i--){
		MouseCoordX[i] = MouseCoordX[i-1];
		MouseCoordY[i] = MouseCoordY[i-1];
	}

	var w = 1;
	var h = 1;	

	switch (browser){
	case "ie5": case "ie4":
		//*** get window dimensions and prevent a div by zero. ***
		if ((w = document.body.clientWidth) < 1) w = 1;
		if ((h = document.body.clientHeight) < 1) h = 1;

		//*** grab mouse co-ords and scale to range -1 to +1. ***
		if (event.button == 1){
			MouseCoordX[0] = ((2 * event.clientX) / w) - 1;
			MouseCoordY[0] =((2 * event.clientY) / h) - 1;
		}
		break;
	case "ns4": case "moz":
		if ((w = window.innerWidth) < 1) w = 1;
		if ((h = window.innerHeight) < 1) h = 1;

		if (mouseEvent.which == 1){
			MouseCoordX[0] = ((2 * mouseEvent.pageX) / w) - 1;
			MouseCoordY[0] = ((2 * mouseEvent.pageY) / h) - 1;
		}
		break;
	}


	window.defaultStatus="MouseX=" + MouseCoordX[0] + ", MouseY=" +MouseCoordY[0];
	return true;
}

document.onmousedown=getMousePos;
if (browser == "ns4" || browser == "moz") window.captureEvents(Event.MOUSEDOWN);
window.onmousedown=getMousePos;

function getKey(keyEvent){
	var keyChar = String.fromCharCode(keyEvent.which);
	switch (keyChar){
		case '1': giveBison(); break;
		case '2': giveCoffee(); break;
		case '3': giveCheese(); break;
		case 'x': case 'X': thumbsUp(); break;
		default: return true;
	}
	return true;
}
if (browser == "ns4" || browser == "moz") document.captureEvents(Event.KEYPRESS);
document.onkeypress=getKey;

//*** Standard clock function. Assigned to a sin curve for repition ****
//*** increment by 10 degrees... 
function getSinTheta(){
	theta += Math.PI * 0.027777;
	return Math.sin(theta);
}

function getCosTheta(){
	theta += Math.PI * 0.027777;
	return Math.cos(theta);
}

//******** Time function. Don't pass time in as a number, since this enjuces bias. *****
//**** Why should 12 O'clock have more influence than 10 O'clock? ***
function is1stQuartOfDay(){
	if (timeNow.getHours() < 6) return 1; else return -1;
}
function is2ndQuartOfDay(){
	if (timeNow.getHours() >= 6 && timeNow.getHours() < 12) return 1; else return -1;
}
function is3rdQuartOfDay(){
	if (timeNow.getHours() >= 12 && timeNow.getHours() < 18) return 1; else return -1;
}
function is4thQuartOfDay(){
	if (timeNow.getHours() >= 18) return 1; else return -1;
}


/*******************************************************************************

Lots of function to handle output from the NN. 
Each take a name of layer and a single value.

*******************************************************************************/

var OUT_COORDS = false;
var OUT_SIZE = false;
var OUT_COLOURS = false;


//*** This function checks and notes down what output the NN is capable of.
function initOutputs(ol){
	if (ol['layerX'] > 0 || ol['layerY']) OUT_COORDS = true;
	if (ol['layerWidth'] > 0 || ol['layerHeight']) OUT_SIZE = true;
	if (ol['layerRed'] > 0 || ol['layerGreen'] || ol['layerBlue']) OUT_COLOURS = true;
}

function sortOutput(layerName, out, ol){
	var w = 1, h = 1;
	switch (browser){
	case "ie5": case "ie4":
		//*** get window dimensions and prevent a div by zero. ***
		if ((w = document.body.clientWidth) < 1) w = 1;
		if ((h = document.body.clientHeight) < 1) h = 1;
		break;
	case "ns4": case "moz":
		if ((w = window.innerWidth) < 1) w = 1;
		if ((h = window.innerHeight) < 1) h = 1;
		break;
	}


	/*** this uses the values in the ol[] array to find out which 
		element of the vector out should be used for what. */
	if (OUT_COORDS)
		moveLayerTo(layerName, 
					((out[ol['layerX']] + 1) * w) / 2, 
					((out[ol['layerY']] + 1) * w) / 2);

	if (OUT_SIZE){
		setLayerSize(layerName, 0.5*w*Math.abs(out[ol['layerWidth']]), 0.5*h*Math.abs(out[ol['layerHeight']]));
	}
	
	if (OUT_COLOURS)
		setColour(layerName, out[ol['layerRed']], out[ol['layerGreen']], out[ol['layerBlue']]);

}


//****** Alter the colour of a layer. ******
function setColour(layerName, r, g, b){
	var rpad, gpad, bpad;

	//** transform from -1 -> +1 to 0 -> 255 ***
	r = Math.round( ((r + 1) * 255) / 2 );
	g = Math.round( ((g + 1) * 255) / 2 );
	b = Math.round( ((b + 1) * 255) / 2 );
	
	//*** make sure we make 2 digit hex numbers ****
	if (r < 16) rpad = "0"; else rpad = ""; 
	if (g < 16) gpad = "0"; else gpad = ""; 
	if (b < 16) bpad = "0"; else bpad = ""; 
	var colour =  '#' + rpad + r.toString(16) + 
		gpad + g.toString(16) + 
		bpad + b.toString(16);

	switch (browser){
	case "moz": case "ns4":
		eval(layerRefA + layerName + layerRefB + '.bgColor="' + colour + '"');
		break;
	case "ie5": case "ie4":
		eval(layerRefA + layerName + layerRefB + '.backgroundColor="' + colour + '"');
		break;
	}
	
	spitDebug("<U>Set layer colour = "+colour+"</U><BR>");

}


function setStatus(string){
	document.status = string;
}



function reshape(){
	switch (browser){
	case "ie5": case "ie4":
		//*** get window dimensions and prevent a div by zero. ***
		if ((w = document.body.clientWidth) < 1) w = 1;
		if ((h = document.body.clientHeight) < 1) h = 1;
		break;
	case "ns4": case "moz":
		if ((w = window.innerWidth) < 1) w = 1;
		if ((h = window.innerHeight) < 1) h = 1;
		break;
	}

	moveLayerTo("Toolbar", 5, h - 100);
}
