<?php

$zIndex = 1;

/*********** Function to spit out a layer *********************
$layerName = ID of layer.
$w, $h = width and height of layer.
$x, $y = x and y coordinates of layer (from top left corner of browser).
*************************************************************/
function spitLayer($layerID, $w, $h, $x, $y, $colour){
	global $zIndex;

	echo "<DIV ID='Beast" . $layerID. "' STYLE='position: absolute; ";
	echo "z-index: $zIndex; ";
	echo "left: " . $x . "px; top: " . $y . "px; ";
	echo "clip:rect(0," . ($x+$w) . "," . ($y+$h) . ",0); ";
	echo "width: " . $w . "px; height: " . $h . "px; ";
	echo "background-color: " . $colour . "; margin: 0px; border: none; ";
	echo "visibility: visible;'>\n";
	echo "<A HREF='beast.php3?id=" . $layerID . "'>\n";

	$zIndex ++;

}

function spitBox($layerName, $w, $h, $x, $y, $colour){
	spitLayer($layerName, $w, $h, $x, $y, $colour);

	echo "<TABLE WIDTH='100%' HEIGHT='100%' CELLPADDING='2' CELLSPACING='0' BORDER='1'>\n";
	echo "\t<TR>\n";
	echo "\t\t<TD BGCOLOR='" . $colour . "'>\n";
	echo "\t\t\t&nbsp;\n";
	echo "\t\t</TD>\n";
	echo "\t</TR>\n";
	echo "</TABLE>\n\n";

	echo "</DIV>\n\n";
}


function spitHeader($title){
echo "
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">
<HTML>

<HEAD>
<TITLE>". $title . "</TITLE>

<META NAME='DESCRIPTION' CONTENT=''>

<META NAME='KEYWORDS' CONTENT=''>

<meta name='GENERATOR' content='Nedit'>
<meta name='FORMATTER' content='Nedit'>
<meta name='AUTHOR' content='Arthur J. Yarwood'>

<LINK href='beast_styles.css' rel='stylesheet' type='text/css'>\n";
}

function spitJSIncludes(){
echo "
<script type='text/javascript' language='javascript1.2' src='http://fubaby.com/include/layers.js'></script>
<script type='text/javascript' language='javascript1.2' src='beast.js'></script>
<script type='text/javascript' language='javascript1.2' src='debug.js'></script>
<script type='text/javascript' language='javascript1.2' src='io_funcs.js'></script>
\n";

}


function spitToolbar($BeastID){
	$res = DQ("SELECT nn_ios.JSFunc FROM nn_nodes
				LEFT JOIN nn_layers ON nn_nodes.LayerID = nn_layers.ID
				LEFT JOIN nn_ios ON nn_nodes.IOID = nn_ios.ID
				WHERE nn_layers.BeastID = '$BeastID' AND nn_ios.InOut = 3");

	echo "<DIV ID=\"Toolbar\">
		<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" BACKGROUND=\"images/grid.gif\">
		<TR>\n";

	echo "<TD>
		<A HREF=\"Javascript: thumbsUp();\" onMouseOver=\"thumbsUp();\">
		<IMG SRC=\"images/thumbs_up.gif\" ALT=\"Thumbs Up\" WIDTH=\"100\" HEIGHT=\"100\" BORDER=\"0\"><BR>
		</A>
		</TD>\n";

	while ($buf = mysql_fetch_array($res)){
		if ($buf['JSFunc'] == "gotCheese"){
			echo "<TD>
				<A HREF=\"Javascript: giveCheese();\">
				<IMG SRC=\"images/cheese.gif\" ALT=\"Give Cheese\" WIDTH=\"100\" HEIGHT=\"100\" 
BORDER=\"0\" NAME=\"CheeseImg\"><BR>
				</A>
				</TD>\n";
		}
		if ($buf['JSFunc'] == "gotCoffee"){
			echo "<TD>
				<A HREF=\"Javascript: giveCoffee();\">
				<IMG SRC=\"images/coffee.gif\" ALT=\"Give Coffee\" WIDTH=\"100\" HEIGHT=\"100\" 
BORDER=\"0\" NAME=\"CoffeeImg\"><BR>
				</A>
				</TD>\n";
		}
		if ($buf['JSFunc'] == "gotBison"){
			echo "<TD>
				<A HREF=\"Javascript: giveBison();\">
				<IMG SRC=\"images/bison.gif\" ALT=\"Give Vokda\" WIDTH=\"100\" HEIGHT=\"100\" 
BORDER=\"0\" NAME=\"BisonImg\"><BR>
				</A>
				</TD>\n";
		}
	}

	echo"</TR>
		</TABLE>
		</DIV>\n";

}


function spitNumOfSquares($BeastID){

	$res = DQ("SELECT COUNT(*) AS num FROM nn_nodes 
				LEFT JOIN nn_layers ON nn_nodes.LayerID=nn_layers.ID 
				LEFT JOIN nn_ios ON nn_nodes.IOID=nn_ios.ID
				WHERE nn_layers.BeastID = '$BeastID' AND nn_ios.InOut = 2");

	$buf = mysql_fetch_array($res);
	echo "var NumOfSquares = " . pow(2, $buf['num']) . ";\n";

}


/************************************************************************************************
This function will psit out the weights for a layer of neurons as a javascript matrix (2d array).
************************************************************************************************/
function spitWeightMatrix($nn_layer_id){
	//*** First find out how many nodes there are in this layer and create an array that big. ***
	$result1 = DQ("SELECT * FROM nn_nodes WHERE LayerID = '$nn_layer_id'");
	$rows = mysql_num_rows($result1);

	echo "LayerWeights" . $nn_layer_id . " = new Array();\n";

	//*** Now make the array 2D with all weight values for each node. *****
	for ($i=0; $i<$rows; $i++){
		$buf1 = mysql_fetch_array($result1);
		$result2 = DQ("SELECT * FROM nn_weights WHERE OutNodeId = '" . $buf1['ID'] . "'");
		echo "LayerWeights" . $nn_layer_id . "[" . $i . "] = new Array(";

		//***** Init 2d array with all weight data. *****
		/* note fudge for when there's only one element...
		  some browser don't know whether to take a single arg in Array()
			as an element or a length value... */
	
		if (($len = mysql_num_rows($result2)) <= 1){
			echo ");\n";
			$buf2 = mysql_fetch_array($result2);
			echo "LayerWeights" . $nn_layer_id . "[" . $i . "][0] = " . $buf2['Weight'] . ";\n";
		}else{
			while ($buf2 = mysql_fetch_array($result2)){
				echo "" . $buf2['Weight'] . "";
				if ($len > 1){ echo ", "; $len --; }
			}
			echo ");\n";
		}
	}
}


function spitLayerOfNodes($nn_layer_id){
	//*** grab all neurons in thislayer out of database. ***
	$result1 = DQ("SELECT * FROM nn_nodes WHERE LayerID = '$nn_layer_id' ORDER BY ID");

	//*** create an array of struct Neuron with the neuronClass constructor ****
	echo "LayerNodes" . $nn_layer_id . " = new neuronClass (";

	$len = mysql_num_rows($result1);
	while ($buf1 = mysql_fetch_array($result1)){
		echo "" . $buf1['Bias'] . ",\"" . $buf1['Func'] . "\"";
			if ($len > 1){ echo ", \n"; $len --; }
	}
	echo ");\n\n";
}


function spitInputJSFunc($BeastID){
	//**** Spit out a function to grab all the inputs and place them in a matrix P. **
	echo "//*** Function grab all the input for the neural network. *****\n";

	$query = "SELECT nn_ios.* FROM nn_ios LEFT JOIN nn_nodes ON nn_nodes.IOID = nn_ios.ID ";
	$query .= "LEFT JOIN nn_layers ON nn_nodes.LayerID = nn_layers.ID ";
	$query .= "WHERE nn_layers.BeastID = '$BeastID' AND nn_layers.Type = 0 ORDER BY nn_nodes.ID";

	$result = DQ($query);

	//** validate results from query. ***
	if (mysql_num_rows($result) <= 0){ return; }

	//*** Now to spit out the unqiue javascript function to grab all the inputs. *****
	echo "var inputP;\n";
	echo "function getInput(){\n";
	echo "\tinputP = new Array();\n";
	
	//*** Fill out the array with all the input functions specified in the data base. *****
	$i = 0;
	while ($buf = mysql_fetch_array($result)){
		echo "\tinputP[$i] = " . $buf['JSFunc'] . ";\n";
		$i ++;
	}

	//echo "\tnormalize(inputP);\n";

	echo "}\n\n";
	
	//*** Chunk to say which inputs are conditional or unconditional . **
		
	//*** rewind 
	mysql_data_seek($result, 0);
	echo "//*** Array to keep track of which input node is condional and which isn't. ***\n";
	echo "var stimulus = new Array();\n";
	$i = 0;
	while ($buf = mysql_fetch_array($result)){
		echo "stimulus[$i] = " . $buf['InOut'] . ";\n";
		$i ++;
	}
	
	echo "\n\n";
}


function spitOutputJSFunc($BeastID){
	echo "//*** Array to keep track of what data is in what element of the NN output matrix. ***\n";

	//**** Spit out a function to take the output matrix, and pass it to various functions. . **
	$query = "SELECT nn_ios.JSFunc FROM nn_ios LEFT JOIN nn_nodes ON nn_nodes.IOID=nn_ios.ID LEFT JOIN nn_layers ON nn_nodes.LayerID=nn_layers.ID ";
	$query .= "WHERE nn_layers.BeastID = '$BeastID' AND nn_layers.Type = 1 ORDER BY nn_nodes.ID";

	$result = DQ($query);

	//** validate results from query. ***
	if (mysql_num_rows($result) <= 0){ return; }

	echo "var OutputFuncs = new Array();\n";
	$i = 0;
	while ($buf = mysql_fetch_array($result)){
		echo "OutputFuncs['" . $buf['JSFunc'] . "'] = $i;\n";
		$i ++;
	}

	echo "initOutputs(OutputFuncs);\n";
}
?>
