/********************************************************************************
This file contains all the gubbins for handling layers. 

********************************************************************************/
//****** Globals *****
var zIndex = 0;				//** keep track of layer z-indices.

/*
document.write("appName: " + navigator.appName + "<BR>");
document.write("appVersion: " + navigator.appVersion + "<BR>");
document.write("appCodeName: " + navigator.appCodeName + "<BR>");
document.write("userAgent: " + navigator.userAgent + "<BR>");
document.write("platform: " + navigator.platform + "<BR>");
*/

//******* These handle general house keeping of layers; initializing, showing, hiding and moving.  *****
if (navigator.appName == "Netscape") {
	if (parseFloat(navigator.appVersion) < 5){
		layerRefA="document.layers['";
		layerRefB="']";
		widthClipRef=".clip.right";
		heightClipRef=".clip.bottom";
		browser = "ns4";
	}else{
		layerRefA="document.getElementById('";
		layerRefB="').style";
		widthClipRef=".width";
		heightClipRef=".height";
		browser = "moz";
	}
}else{
	if (navigator.appVersion.indexOf("5.") == -1){
		layerRefA="document.all['";
		layerRefB="'].style";
		widthClipRef=".width";
		heightClipRef=".height";
		browser = "ie4";
	}else{
		layerRefA="document.getElementById('";
		layerRefB="').style";
		widthClipRef=".width";
		heightClipRef=".height";
		browser = "ie5";
	}
}

function showLayer(layerName){
	eval(layerRefA + layerName + layerRefB + '.visibility="visible"');
}

function hideLayer(layerName){
	eval(layerRefA + layerName + layerRefB + '.visibility="hidden"');
}

function moveLayerTo(layerName, x, y){
	switch (browser){
	case "moz": case "ie5":
		eval(layerRefA + layerName + layerRefB + '.top="' + y + 'px"');
		eval(layerRefA + layerName + layerRefB + '.left="' + x + 'px"');
		break;
	case "ns4": case "ie4":
		eval(layerRefA + layerName + layerRefB + '.top="' + y + '"');
		eval(layerRefA + layerName + layerRefB + '.left="' + x + '"');
		break;
	}
}

//**** Couple of functions to resize a layer... **********
function setLayerSize(layerName, w, h){
	w = Math.floor(w);
	if (w < 1) w = 1;
	eval(layerRefA + layerName + layerRefB + widthClipRef + '=' + w );

	h = Math.floor(h);
	if (h < 1) h = 1;
	eval(layerRefA + layerName + layerRefB + heightClipRef + '=' + h );
}

function refName(layerName, itemName){
	switch (browser){
	case "ie5":
		return "document.getElementById('" + itemName + "')";
		break;
	case "ie4": case "moz":
		return "document." + itemName;
		break;
	case "ns4":
		return "document.layers['" + layerName + "'].document." + itemName;
		break;
	}
}


/*******************************************************************************

	Stuff to spit out a new layer...

*******************************************************************************/

function spitLayer(layerName, w, h, x, y, colour){
	switch (browser){
	case "ns4":
		//*** create layer **
		var newLayer = new Layer(w);
		newLayer.clip.right = w;
		newLayer.clip.bottom = h;
		newLayer.left = x;
		newLayer.top = y;
		newLayer.zIndex = zIndex;
		newLayer.visibility = 'visible';
		newLayer.bgColor = colour;
		//** store it's name. ***
		eval("layerNames['" + layerName + "'] = newLayer.id");
		break;

	case "ie5": case "moz":
		//** same as above, but using the DOM method... 
		docBody = document.getElementsByTagName("body").item(0);
		var newLayer = document.createElement('DIV');
		newLayer.style.position = 'absolute';
		newLayer.style.visibility = 'visible';
		newLayer.style.zIndex = zIndex;
		newLayer.style.width =  w + 'px';
		newLayer.style.height = h + 'px';
		newLayer.style.left = x + 'px';
		newLayer.style.top = y + 'px';
		newLayer.id = layerName;
		newLayer.style.backgroundColor = colour;

		docBody.appendChild(newLayer);
		eval("layerNames['" + layerName + "'] = '" + layerName + "'");
		break;

	case "ie4":
		//** IE4 dunna have a layer constructor so we do it this way. ***
		var newLayer = "<DIV ID='" + layerName + "' STYLE='position: absolute;";
		newLayer += " left: " + x + "px; top: " + y + "px;";
		newLayer += " width: " + w + "px; height: " + h + "px;";
		newLayer += " background-color: " . color + ";";
		newLayer += " z-index: " + zIndex + ";";
		newLayer += "'><\/DIV>";
		eval("layerNames['" + layerName + "'] = " + layerName);
		document.body.insertAdjacentHTML('beforeEnd', html);
		break;
	}
	zIndex++;
}


