<?php

require ("admincommon.php3");
require ("../common.php3");
require ("../../include/beastpass.php3");

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>

<HEAD>
<TITLE>Create a Beast</TITLE>

<META NAME='DESCRIPTION' CONTENT=''>

<META NAME='KEYWORDS' CONTENT=''>

<meta name='GENERATOR' content='nedit'>
<meta name='FORMATTER' content='nedit'>
<meta name='AUTHOR' content='Arthur J. Yarwood'>

<LINK href='beast_admin_styles.css' rel='stylesheet' type='text/css'>

<SCRIPT LANGUAGE="javascript1.1" type="text/javascript">
<!--

function confirmDel(){
	if (confirm("Are you sure you want to kill this beast?")){
		return true;
	}else{
		return false;
	}
}

function valForm(){
	if (document.CreateForm.NumLayers < 1 || document.CreateForm.NumLayers ==''){ 
		alert ("You need at least some hidden layers!");
		return false;
	}
	if (document.CreateForm.NodesPerLayer < 1 || document.CreateForm.NodesPerLayer ==''){
		alert ("You need at least 1 node in a layer.");
		return false;
	}
	if (document.CreateForm.BeastName == ''){
		alert ("You must give the beast a name.");
		return false;
	}

	return true;
}

//-->
</SCRIPT>

</HEAD>

<BODY>

<?php
if ($submit){
	//*** quick security check... 
	if ($Pass != $beastpass){ 
		echo "<H1>Bad Pass</H1>\n\n";
		return; 
	}
}

switch ($submit){
case 'Create':
	//*** wee bit of error checking in submitted vars. ***
	if ($BeastName == ''){ echo "Need a name for Beast.<BR>"; break; }
	if (sizeof($InputIO) < 1){ echo "Must have some Input functions.<BR>"; break; }
	if (sizeof($OutputIO) < 1){ echo "Must have some Output functions.<BR>"; break; }
	if ($NumLayers < 1){ echo "Must have at least some hidden layers.<BR>"; break; }
	if ($NodesPerLayer < 1){ echo "Must have some nodes in hidden layers.<BR>"; break; }

	//*** work out stucture of network, 4:3:5 etc... *****
	$structure = sizeof($InputIO) . ":";
	for ($k=0; $k<$NumLayers; $k++){
		$structure .= $NodesPerLayer . ":";
	}
	$structure .= sizeof($OutputIO);

	mt_srand(time());	// seed random number generator. 
	$randx = (mt_rand() / mt_getrandmax()) * 600;
	$randy = (mt_rand() / mt_getrandmax()) * 600;

	//**** First lets create the beast entry. ****
	$query = "INSERT INTO nn_beasts (Name, X, Y, DOB, Structure) 
		VALUES ('".addslashes($BeastName)."',
				".$randx.",
				".$randy.",
				CURDATE(),
				'$structure')";
	DQ($query);
	$beastID = mysql_insert_id();

	//****************************** make the input layer. ***************************************
	DQ("INSERT INTO nn_layers (BeastID, Type, Training) VALUES ($beastID, 0, 'instar')");	// this last '0' signifies an input layer. 
	$inputlayerID = mysql_insert_id();

	//*** now to create the nodes that go in it. ****
	sort($InputIO);
	for ($i=0; $i<sizeof($InputIO); $i++){
		if (!empty($InputIO[$i])){
			DQ("INSERT INTO nn_nodes (LayerID, Bias, Func, IOID) VALUES ($inputlayerID, 0, 'inputNode', ".$InputIO[$i].")");
		}else{
			DQ("INSERT INTO nn_nodes (LayerID, Bias, Func) VALUES ($inputlayerID, 0, 'inputNode')");
		}
	}

	//********************************* Now to sort out all the hidden layers. *************************
	for ($i=0; $i<$NumLayers; $i++){
		DQ("INSERT INTO nn_layers (BeastID, Type) VALUES ($beastID, 2)");	// this last '2' signifies a hidden layer. 
		$layerID = mysql_insert_id();

		for ($j=0; $j<$NodesPerLayer; $j++){
			DQ("INSERT INTO nn_nodes (LayerID, Bias, Func) VALUES ($layerID, 1, '$HiddenFunc')");
		}
	}
	
	//*********************************** Finally make the output layer. ***************************
	DQ("INSERT INTO nn_layers (BeastID, Type, Training) VALUES ($beastID, 1, 'outstar')");	// this last '1' signifies an output layer. 
	$outputlayerID = mysql_insert_id();

	$autoFuncRes = DQ("SELECT ID,DefaultFunc FROM nn_ios ORDER BY ID ASC");
	sort($OutputIO);

	//*** put all them funcs into an array, so array index matches func ID. ****
	//*** fixes trouble with gaps in MySQL ID sequence... ****
	while ($autobuf = mysql_fetch_array($autoFuncRes)){
		$autoFuncsArray[$autobuf['ID']] = $autobuf['DefaultFunc'];
	}

	//*** now to create the nodes that go in it. ****
	for ($i=0; $i<sizeof($OutputIO); $i++){
		//** if this is auto, get Func from IOID database table.   ****
		if ($OutputFunc == "Auto" && !empty($OutputIO[$i])){
			$thisOutFunc = $autoFuncsArray[$OutputIO[$i]];
		}else{
			$thisOutFunc = "hardlim";	//** the default, when we don't have a clue. **
		}

		//** now to actually insert the output node. ***
		if (!empty($OutputIO[$i])){
			DQ("INSERT INTO nn_nodes (LayerID, Bias, Func, IOID) VALUES ($outputlayerID, 1, '$thisOutFunc', ".$OutputIO[$i].")");
		}else{
			DQ("INSERT INTO nn_nodes (LayerID, Bias, Func) VALUES ($outputlayerID, 1, '$thisOutFunc')");
		}
	}

	//************ Next we need to connect all these layers of nodes up using the 'weight' structure. *********

	//*** first we'll grab all the hidden layer ID's... ***
	$result1 = DQ("SELECT ID,Type FROM nn_layers WHERE BeastID= '$beastID' AND Type != '0' ORDER BY ID");
	$i = 1;
	$layerIDs[0] = $inputlayerID;

	//******* Loop through all the layers, except first, as that won't have any weights... *******
	while ($buf1 = mysql_fetch_array($result1)){

		//*** Put layer ID's into an array so we can access previous. ****
		$layerIDs[$i] = $buf1['ID'];

		//*** Get ID's of nodes in current layer and one previous. ****
		$currentLayerRes = DQ("SELECT ID FROM nn_nodes WHERE LayerID = '" . $layerIDs[$i] . "' ");
		$prevLayerRes = DQ("SELECT ID FROM nn_nodes WHERE LayerID = '" . $layerIDs[$i-1] . "' ");
		
		//*** Loop through current row neurons, and generate a normalized input weight matrix for each. ***
		while ($curBuf = mysql_fetch_array($currentLayerRes)){
			mysql_data_seek($prevLayerRes, 0);	//** rewind previous layers mysql result **

			//***** Loop through all the nodes in layer previous and create weights between them and current node. ****
			while ($prevbuf = mysql_fetch_array($prevLayerRes)){
				$weightVal = (mt_rand() / mt_getrandmax()) * ($WMax - $WMin) + $WMin;
				//** insert a weight into database. Weight is set randomly between -2 and +2. ****
				$query = "INSERT INTO nn_weights (Weight, InNodeID, OutNodeID) ";
				$query .= "VALUES (" . $weightVal . "," . $prevbuf['ID'] . "," . $curBuf['ID'] . ")";
				DQ ($query);
			}
		}

		$i++;

	}
	echo "<H2>Beast '$BeastName' born.</H2><HR WIDTH='905'><BR>";
	break;

case 'Del':
	//**** chunk to delete a beast. ***
	//*** grab all ids of layers to this beast. ****
	$layer_res = DQ("SELECT ID FROM nn_layers WHERE BeastID='$ID'");
	
	//*** loop through layers. ****
	while ($layer_buf = mysql_fetch_array($layer_res)){
		//*** grab all nodes in this layer. ****
		$node_res = DQ("SELECT ID FROM nn_nodes WHERE LayerID='".$layer_buf['ID']."'");
		
		//*** loop through nodes in this layer. ****
		while ($node_buf = mysql_fetch_array($node_res)){
			//*** delete any weights that connect to this node. ***
			DQ("DELETE FROM nn_weights WHERE OutNodeID='".$node_buf['ID']."' OR InNodeID='".$node_buf['ID']."'");
		}
	
		//** now delete the nodes in this layer. ***
		DQ("DELETE FROM nn_nodes WHERE LayerID='".$layer_buf['ID']."'");
	}
	//** now delete all the layers to this beast. ***
	DQ("DELETE FROM nn_layers WHERE BeastID='$ID'");

	$result = DQ("SELECT Name FROM nn_beasts WHERE ID='$ID'");
	$buf = mysql_fetch_array($result);

	//** now delete the beast itself. ***
	DQ("DELETE FROM nn_beasts WHERE ID='$ID'");


	
	echo "<H4>Beast '".$buf['Name']."' killed.</H4>";
	break;

default:
	break;

}

//****** Spit out form to create a new beast. *****
	echo "<H1>Create a New Beast:- </H1>\n";

	echo "<FORM METHOD='post' ACTION='" . $PHP_SELF . "' NAME='CreateForm' onSubmit='return valForm();'>\n";
	echo "<H4>Number of Hidden Layers: <INPUT TYPE='TEXT' NAME='NumLayers' SIZE='5' MAXLENGTH='5'><BR>\n";
	echo "Nodes Per Layer: <INPUT TYPE='TEXT' NAME='NodesPerLayer' SIZE='5' MAXLENGTH='5'>\n";
	echo "Func <SELECT NAME='HiddenFunc'>\n";
	spitFuncSelect(NULL);
	echo "</H4><HR width='90%'>\n\n";

//**************************************************************************************************

	echo "<H4>Input Layer:-</H4>\n";
	echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='0' CELLSPACING='0'>\n<TR>\n<TD><H5>\n";

	$ioFuncRes = DQ("SELECT * FROM nn_ios WHERE InOut >= 0 AND InOut < 10");
	$numPerRow = (float) mysql_num_rows($ioFuncRes) / 3;	
	$count = 1;
	while ($iofuncbuf = mysql_fetch_array($ioFuncRes)){
		echo "<INPUT TYPE='CHECKBOX' NAME='InputIO[]' VALUE='".$iofuncbuf['ID']."'> ".$iofuncbuf['JSFunc']."<BR>\n";
		if ($count > $numPerRow){
			echo "</H5></TD>\n<TD><H5>\n";
			$count = 1;
		}else{
			$count ++;
		}
	}
	echo "</H5></TD></TR></TABLE>\n\n";

//**************************************************************************************************

	echo "<HR width='90%'>\n\n";

	echo "<H4>Output Layer:-</H4>\n";
	echo "Func <SELECT NAME='OutputFunc'>\n";
	echo "<OPTION>Auto\n";
	spitFuncSelect(NULL);
	echo "<BR>\n";
	echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='0' CELLSPACING='0'>\n<TR>\n<TD><H5>\n";

	$ioFuncRes = DQ("SELECT * FROM nn_ios WHERE InOut >= 10");
	$numPerRow = (float) mysql_num_rows($ioFuncRes) / 3;	
	$count = 1;
	while ($iofuncbuf = mysql_fetch_array($ioFuncRes)){
		echo "<INPUT TYPE='CHECKBOX' NAME='OutputIO[]' VALUE='".$iofuncbuf['ID']."'> ".$iofuncbuf['JSFunc']."<BR>\n";
		if ($count > $numPerRow){
			echo "</H5></TD>\n<TD><H5>\n";
			$count = 1;
		}else{
			$count ++;
		}
	}
	echo "</H5></TD></TR></TABLE>\n\n";

//**************************************************************************************************

	echo "<HR width='90%'>\n<H4>\n";
	echo "Weight Range: Min-<INPUT TYPE='TEXT' NAME='WMin' SIZE='4' MAXLENGTH='5' VALUE='-1'>\n";
	echo "Max-<INPUT TYPE='TEXT' NAME='WMax' SIZE='4' MAXLENGTH='5' VALUE='1'><BR><BR>\n";
	echo "Beast Name: <INPUT TYPE='TEXT' NAME='BeastName' SIZE='16' MAXLENGTH='24'><BR>\n";
	echo "Password: <INPUT TYPE='PASSWORD' NAME='Pass'><BR>\n";
	echo "<INPUT TYPE='SUBMIT' VALUE='Create' NAME='submit'>\n\n";
	echo "</H4>\n</FORM>\n<BR><HR width='100%'>\n\n\n";


///********************* chunk to list all beast in database. ********************
?>
<A NAME="View">
<H1>Beasts in Database:- </H1>
<?php
$result = DQ ("SELECT *,(TO_DAYS(CURDATE()) - TO_DAYS(DOB)) AS Age  FROM nn_beasts ORDER BY DOB");


while ($buf = mysql_fetch_array($result)){
	echo "<H4><A HREF='dispBeast.php3?BeastID=" . $buf['ID'] . "'>\n";
	echo "Beast: ".$buf['Name']."</A> | Age: ".$buf['Age']." days | Hits: ".$buf['Hits']."</H4>\n";
	echo "<FORM METHOD='post' ACTION='" . $PHP_SELF . "' onSubmit='return confirmDel();'>\n";
	echo "<INPUT TYPE='HIDDEN' NAME='ID' VALUE='".$buf['ID']."'>\n";
	echo "<INPUT TYPE='SUBMIT' VALUE='Del' NAME='submit'>\n";
	echo "Password: <INPUT TYPE='PASSWORD' NAME='Pass'>\n\n";
	echo "</FORM>\n\n";
}

?>

</BODY>
</HTML>
